--characterTemplate = { }

CharacterTemplate = {
  age         = "",
  alignment   = "",
  class       = "",
  faith       = "",
  feature     = "",
  gender      = "",
  name        = "",
  race        = "",
  tribe       = "",
  
  motivations = { "", "", "" }
}

CharacterTemplate.getAge        = function(self)    return self.age                end
CharacterTemplate.getAlignment  = function(self)    return self.alignment          end
CharacterTemplate.getClass      = function(self)    return self.class              end
CharacterTemplate.getFaith      = function(self)    return self.faith              end
CharacterTemplate.getFeature    = function(self)    return self.feature            end
CharacterTemplate.getGender     = function(self)    return self.gender             end
CharacterTemplate.getName       = function(self)    return self.name               end
CharacterTemplate.getRace       = function(self)    return self.race               end
CharacterTemplate.getTribe      = function(self)    return self.tribe              end
CharacterTemplate.getMotivation = function(self, i) return self.motivations[i]     end

CharacterTemplate.setAge        = function(self, x)        self.age = x            end
CharacterTemplate.setAlignment  = function(self, x)        self.alignment = x      end
CharacterTemplate.setClass      = function(self, x)        self.class = x          end
CharacterTemplate.setFaith      = function(self, x)        self.faith = x          end
CharacterTemplate.setFeature    = function(self, x)        self.feature = x        end
CharacterTemplate.setGender     = function(self, x)        self.gender = x         end
CharacterTemplate.setName       = function(self, x)        self.name = x           end
CharacterTemplate.setRace       = function(self, x)        self.race = x           end
CharacterTemplate.setTribe      = function(self, x)        self.tribe = x          end
CharacterTemplate.setMotivation = function(self, i, x)     
  if i == 1 or self.motivations[1] == "" then
    i = 1
  elseif i == 2 or self.motivations[2] == "" then
    i = 2
  else
    i = 3
  end
  
  self.motivations[i] = x
end

function CharacterTemplate:new()
  instance = { }
  setmetatable(instance, self)
  self.__index = self
  return instance
end








function npcGenerator_OnLoad(self)
  characterTemplate = CharacterTemplate:new()
  --[[
  characterTemplate.Motivation = { }
  characterTemplate.getName       = function(self)  return getInternalName(string.lower(box_Name:GetText()))       end
  characterTemplate.getRace       = function(self)  return getInternalName(string.lower(box_Race:GetText()))       end
  characterTemplate.getTribe	  	= function(self)  return getInternalName(string.lower(box_Tribe:GetText()))	   	 end
  characterTemplate.getGender     = function(self)  return getInternalName(string.lower(box_Gender:GetText()))     end
  characterTemplate.getClass      = function(self)  return getInternalName(string.lower(box_Class:GetText()))      end
  characterTemplate.getAlignment  = function(self)  return getInternalName(string.lower(box_Alignment:GetText()))  end
  characterTemplate.getAge        = function(self)  return getInternalName(string.lower(box_Age:GetText()))        end
  characterTemplate.getFaith      = function(self)  return getInternalName(string.lower(box_Faith:GetText()))      end
  characterTemplate.getFeature    = function(self)  return getInternalName(string.lower(box_Feature:GetText()))    end
  characterTemplate.getMotivation = function(self, i) 
    if i == 1 then
      return string.lower(box_Motivation1:GetText())
    elseif i == 2 then
      return string.lower(box_Motivation2:GetText())
    elseif i == 3 then
      return string.lower(box_Motivation3:GetText())
    end
  end
  
  characterTemplate.setName       = function(self, x)  box_Name:SetText(      ucWords(x)) end
  characterTemplate.setRace       = function(self, x)  box_Race:SetText(      ucWords(x)) end
  characterTemplate.setTribe	  	= function(self, x)
    -- Change interface to reflect context, like:
    -- undead uses "subrace";
    -- tauren uses  "tribe";
    local tribeContext = ucFirst(getTribeContext(characterTemplate.getRace()))
    frm_Main.charTribe:SetText(tribeContext)
    -- If a race has no context for this trait, remove the visibility.
    if tribeContext == "" then
      box_Tribe:SetText("")
      --box_Tribe:Hide()
      --frm_Main.rollTribe:Hide()
    else
      --box_Tribe:Show()
      box_Tribe:SetText(ucWords(x))
      --frm_Main.rollTribe:Show()
    end
  end
  characterTemplate.setGender     = function(self, x)  box_Gender:SetText(    ucFirst(x)) end
  characterTemplate.setClass      = function(self, x)  box_Class:SetText(     ucWords(x)) end
  characterTemplate.setAlignment  = function(self, x)  box_Alignment:SetText( ucWords(x)) end
  characterTemplate.setAge        = function(self, x)  box_Age:SetText(       ucWords(x)) end
  characterTemplate.setFaith      = function(self, x)  box_Faith:SetText(     ucWords(   
                                        processSubstitutionString(characterTemplate, x))) end
  characterTemplate.setFeature    = function(self, x)  box_Feature:SetText(   ucFirst(x)) end
  characterTemplate.setMotivation = function(self, i, x) 
    x = processSubstitutionString(characterTemplate, x)
    if i == 1 then
      return box_Motivation1:SetText(ucFirst(x))
    elseif i == 2 then
      return box_Motivation2:SetText(ucFirst(x))
    elseif i == 3 then
      if box_Motivation2:GetText() == "" and x ~= "" then
        return box_Motivation2:SetText(ucFirst(x))
      else
        return box_Motivation3:SetText(ucFirst(x))
      end
    end
  end
  ]]
end

-- End of File.